//Designed to be printed in TPU or another flexible material

thickness = 2.8;
id = 16;
length =  70;
bend_stepout = 4;
bend_height = 3;
n_bends = 5;
barb_height = 15;
barb_retainer_height = 4;
retainer_thickness = 0.8;

$fn = 64;
bend_id = id + bend_stepout;


bendy_height = (n_bends + 1) * (bend_height) * 2;
echo(bendy_height + 2 * barb_height);

module flex(maj, minor, bend_height, n){
    for (bend_num = [0 : n]){
        translate([0,0,bend_num * bend_height * 2])
        cylinder(h = bend_height, d1 = minor, d2 = maj);
        translate([0,0,bend_height + bend_num * (bend_height * 2)])
        cylinder(h = bend_height, d2 = minor, d1 = maj);
    }
}

//lower smooth tube
difference(){
    cylinder(h=barb_height, d = id + thickness);
    cylinder(h=barb_height, d = id);
}
//Retainer
difference(){
    cylinder(barb_retainer_height, d = id + thickness);
    cylinder(barb_retainer_height, d = id - retainer_thickness);
}
translate([0,0,barb_height])
difference(){
    flex(bend_id + thickness, id + thickness, bend_height, n_bends);
    flex(bend_id, id, bend_height, n_bends);
}
translate([0,0,barb_height + bendy_height])
difference(){
    cylinder(h=barb_height, d = id + thickness);
    cylinder(h=barb_height, d = id);
}
//Retainer
translate([0,0,barb_height + bendy_height + (barb_height - barb_retainer_height)])
difference(){
    cylinder(barb_retainer_height, d = id + thickness);
    cylinder(barb_retainer_height, d = id - retainer_thickness);
}
